VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' In this approach, instead of using events, we set the procedure for drawing the report with the
' SetPrintingProcedure method of the PrintPreview object
' That method must be declared Public.
' It is named PrepareReport1 in this sample

' Public method to invoque printing
Public Sub PrintReport()
    
    ' set a ReportID to identify this report and to enable to save the user preferences for it
    PrintPreview.ReportID = "Class1.SampleReport"
    ' set the procedure to print the report
    PrintPreview.SetPrintingProcedure Me, "PrepareReport1"
    
    ' display the print preview dialog
    PrintPreview.ShowPreview
End Sub

' print/draw the report here
' this method must be declared Public
Public Sub PrepareReport1()
    Printer.Print "Hello World"
End Sub

